use crate::notification::Notification;

impl Notification {
    // Plain string format, useful for printing
    pub fn plain(&self) -> String {
        // Actions
        let mut actions: String = String::new();
        if self.actions().is_empty() {
            actions = "None".to_string();
        } else {
            for actn in &self.actions() {
                actions = actions + "\n\t" + actn.0.as_str() + ": " + actn.1.as_str();
            }
        }
        // Default action
        let default_action: String = match self.default_action() {
            None => "None".to_string(),
            Some(actn) => actn.0,
        };
        // Hints
        let mut hints: String = String::new();
        if self.hints().is_empty() {
            hints = "None".to_string();
        } else {
            for (key, value) in self.hints() {
                hints = hints + "\n\t" + key + ": " + &value.to_string();
            }
        }

        // Return the notification as a plain string
        let plain_string = format!("App Name: {}\nReplace ID: {}\nIcon: {}\nSummary: {}\nBody: {}\nActions: {}\nHints: {}\nExpiration Timeout: {}\nUrgency: {}\nDefault Action: {}",
                        &self.app_name(),
                        &self.replace_id().to_string(),
                        &self.icon(),
                        &self.summary(),
                        &self.body(),
                        actions,
                        hints,
                        &self.expir_timeout().to_string(),
                        &self.urgency(),
                        default_action,
                    );
        plain_string
    }
}
